.486
.model flat, stdcall
option casemap :none
  
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\dialogs.inc
include \masm32\include\winmm.inc
include \masm32\include\msimg32.inc
   
   
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\msimg32.lib
   
include \masm32\macros\macros.asm

WndProc        PROTO :DWORD, :DWORD, :DWORD, :DWORD
NouvelleEtoile PROTO :DWORD ; New Star
Random         PROTO :DWORD

.const 
IDI_ICON    equ 200
IDD_DLG1    equ 101


NbEtoiles equ 1000 ; No. Stars
TailleStructEtoile equ 28 ;Size Struct Star
VitesseMin equ 1 ; Low Speed or speedmin
VitesseMax equ 10 ;Max speed or speedmax
.data
szTitle      db 'Starfiled with resource example', 0   
noir dd 00000000h
EstNvEtoile db FALSE ;Eastern Star Nv
Vitesse dd 2 ;speed
AfficheTraine db TRUE ;Drive type displayed or Displays Trolling
   
.data?
hInstance       HINSTANCE ?
hIcon     HICON     ?
hDialog       HWND ?

WindowRect      RECT     <?, ?, ?, ?>
MyRect          RECT     <?, ?, ?, ?>
rClientWindow   RECT     <?, ?, ?, ?>

  
Xfenetre dd ? ;window
Yfenetre dd ?
Xfenetrediv2 dd ?
Yfenetrediv2 dd ?
hEtoiles HANDLE ? ;H Stars
pEtoiles dd ? ;P Stars
NombrePrRandom dd ? ;Random Name Pr
rect RECT <?, ?, ?, ?>
  
.code
start:
   
   
mov hInstance,rv(GetModuleHandle,0)
INVOKE InitCommonControls  
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR WndProc, 0
INVOKE ExitProcess, 0

WndProc PROC uses  ebx esi edi hWnd:HWND,uMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL hDC:HANDLE
LOCAL hMemDC:HANDLE         
LOCAL hBmp:HANDLE
LOCAL ps:PAINTSTRUCT


.IF uMsg ==  WM_INITDIALOG

INVOKE SetWindowText, hWnd, addr szTitle 
INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon

INVOKE  GetClientRect,hWnd,ADDR rect


m2m Xfenetre,rect.right
m2m Yfenetre,rect.bottom


invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NbEtoiles * TailleStructEtoile
mov hEtoiles, eax
invoke GlobalLock, hEtoiles
mov pEtoiles, eax



;.ELSEIF  uMsg ==  WM_COMMAND
.ELSEIF uMsg == WM_KEYDOWN
.IF wParam == VK_ESCAPE
  INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
  .ENDIF
.ELSEIF uMsg ==  WM_CLOSE
invoke GlobalUnlock, pEtoiles
 invoke GlobalFree, hEtoiles
  INVOKE EndDialog, hWnd, 0

.ELSEIF wParam == VK_PGDN
.IF Vitesse != VitesseMin
dec Vitesse
 .ENDIF
.ELSEIF wParam == VK_PGUP
.IF Vitesse != VitesseMax
 inc Vitesse
.ENDIF
.ELSEIF wParam == VK_T
.IF AfficheTraine
mov AfficheTraine, FALSE
.ELSE
 mov AfficheTraine, TRUE
.ENDIF
.ENDIF   

.IF  uMsg == WM_PAINT
invoke GetClientRect,hWnd,ADDR rect
mov hDC,rv(BeginPaint,hWnd,ADDR ps)
mov hDC, eax
invoke CreateCompatibleDC, hDC
mov hMemDC, eax
invoke CreateCompatibleBitmap, hDC, Xfenetre, Yfenetre
 mov hBmp, eax
invoke SelectObject, hMemDC, hBmp
invoke FillRect, hMemDC, OFFSET rect,rv(GetStockObject,BLACK_BRUSH)

xor ecx, ecx

.WHILE ecx != NbEtoiles ;NbEtoile=No. Stars
mov eax, TailleStructEtoile ;TailleStructEtoile=Size Struct Star
mul ecx
add eax, pEtoiles
mov ebx, eax
;----------------------------------------------;
;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
mov eax, Vitesse
.IF dword ptr [ebx + 8] <= eax
push ecx
invoke NouvelleEtoile, ebx  ;NouvelleEtoile=New Star
pop ecx
mov EstNvEtoile, TRUE
.ENDIF
;----------------------------------------------;
;--- REPLACEMENT OF OLD ADDRESS ---;
.IF AfficheTraine ; AfficheTraine=Displays Trolling or Drive type displayed???
push dword ptr [ebx + 12]
pop dword ptr [ebx + 20]
push dword ptr [ebx + 16]
pop dword ptr [ebx + 24]
.ENDIF
;----------------------------------------;
;--- CALCULATION OF NEW ADDRESS ---;
mov eax, Vitesse     ; Vitesse = Speed
sub dword ptr [ebx + 8], eax
mov eax, dword ptr [ebx]
shl eax, 8
cdq
idiv dword ptr [ebx + 8]
add eax, Xfenetrediv2
mov dword ptr [ebx + 12], eax
mov eax, dword ptr [ebx + 4]
shl eax, 8
cdq
idiv dword ptr [ebx + 8]
add eax, Yfenetrediv2
mov dword ptr [ebx + 16], eax
;---------------------------;
;--- CORRECTION OF BUGS ---;
.IF AfficheTraine && EstNvEtoile ;Eastern Star Nv
push dword ptr [ebx + 12]
pop dword ptr [ebx + 20]
push dword ptr [ebx + 16]
pop dword ptr [ebx + 24]
mov EstNvEtoile, FALSE
.ENDIF
;--------------------------------------------------------------------;
;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
mov eax, Xfenetre
mov edx, Yfenetre    ;fenetre=window
.IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
mov dword ptr [ebx + 8], 0
.ENDIF
push ecx
;---------------------------;
;--- COLOR OF THE STAR ---;
xor eax, eax
mov ah, cl
mov al, ah
shl eax, 8
mov al, ah
invoke CreatePen, PS_SOLID, NULL, eax
push eax
invoke SelectObject, hMemDC, eax
;--------------------------;
;--- DRAWING FROM THE STAR ---;
push NULL
.IF AfficheTraine
push dword ptr [ebx + 24]
push dword ptr [ebx + 20]
.ELSE
mov eax, dword ptr [ebx + 16]
inc eax
push eax
push dword ptr [ebx + 12]
.ENDIF
push hMemDC
call MoveToEx
invoke LineTo, hMemDC, dword ptr [ebx + 12], dword ptr [ebx + 16]
pop eax
invoke DeleteObject, eax
pop ecx
inc ecx
.ENDW
invoke BitBlt, hDC, 0, 0, Xfenetre, Yfenetre, hMemDC, 0, 0, SRCCOPY
invoke DeleteObject, hBmp
invoke DeleteDC, hMemDC
invoke EndPaint, hWnd, ADDR ps
.ELSE
invoke DefWindowProc, hWnd, uMsg, wParam, lParam
ret 
.ENDIF
xor eax, eax
ret


;--------------------------------------------------------------------
WndProc ENDP
NouvelleEtoile PROC uses ebx pEtoile:DWORD
mov ebx, pEtoile
invoke Random, Xfenetre
sub eax, Xfenetrediv2
mov dword ptr [ebx], eax
invoke Random, Yfenetre
sub eax, Yfenetrediv2
mov dword ptr [ebx + 4], eax
mov dword ptr [ebx + 8], 256
push Xfenetrediv2
pop dword ptr [ebx + 12]
push Yfenetrediv2
pop dword ptr [ebx + 16]
mov eax, pEtoile
ret
NouvelleEtoile ENDP  ;NouvelleEtoile= New Star

Random PROC Limite:DWORD
mov eax, NombrePrRandom
mov ecx, 23
mul ecx
add eax, 7
and eax, 0FFFFFFFFh
ror eax, 1
xor eax, NombrePrRandom
mov NombrePrRandom, eax
mov ecx, Limite ;Limit
xor edx, edx
div ecx
mov eax, edx
ret
Random ENDP
END start